import 'package:flutter/material.dart';
import 'package:myanmar_administrative_areas/myanmar_administrative_areas.dart';

class VillageExample extends StatefulWidget {
  const VillageExample({super.key});

  @override
  State<VillageExample> createState() => _VillageExampleState();
}

class _VillageExampleState extends State<VillageExample> {
  String? selectedValue1;
  String? selectedValue2;
  String? selectedValue3;

  List<String> items2 = [];
  List<String> items3 = [];
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('ကျေးရွာ နမူနာ'),
      ),
      body: Padding(
        padding: const EdgeInsets.all(32.0),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.start,
          children: [
            buildDropdown1(),
            const SizedBox(height: 16),
            items2.isNotEmpty ? buildDropdown2() : Container(),
            const SizedBox(height: 16),
            items3.isNotEmpty ? buildDropdown3() : Container(),
            const SizedBox(
              height: 30.0,
            ),
            Row(
              children: [
                Expanded(
                  child: FilledButton(
                      onPressed: () => {}, child: const Text("ပြီးပါပြီ")),
                ),
                const SizedBox(
                  height: 50.0,
                ),
              ],
            ),
            (selectedValue1 != null &&
                    selectedValue2 != null &&
                    selectedValue3 != null)
                ? Text(
                    "$selectedValue1\n$selectedValue2 မြို့နယ် \n$selectedValue3 ကျေးရွာ",
                    style: const TextStyle(fontSize: 20.0),
                    textAlign: TextAlign.center,
                  )
                : Container()
          ],
        ),
      ),
    );
  }

  Widget buildDropdown1() {
    return DropdownButtonFormField<String>(
      value: selectedValue1,
      hint: const Text('ပြည်နယ် နှင့် တိုင်းရွေးပါ'),
      onChanged: (String? value) {
        setState(() {
          selectedValue1 = value;
          selectedValue3 = null;
          selectedValue2 = null;
          items2 = townshipsAsDivisionMy[selectedValue1] ?? [];
          items3 = [];
        });
      },
      items: divisionMy.map((String item) {
        return DropdownMenuItem<String>(
          value: item,
          child: Text(item),
        );
      }).toList(),
    );
  }

  Widget buildDropdown2() {
    return DropdownButtonFormField<String>(
      value: selectedValue2,
      hint: const Text('မြို့နယ်ရွေးပါ'),
      onChanged: (String? value) {
        setState(() {
          selectedValue2 = value;
          selectedValue3 = null;
          items3 = villagesAsTownshipMy[selectedValue2] ?? [];
        });
      },
      items: items2.map((String item) {
        return DropdownMenuItem<String>(
          value: item,
          child: Text("$item မြို့နယ်"),
        );
      }).toList(),
    );
  }

  Widget buildDropdown3() {
    return DropdownButtonFormField<String>(
      value: selectedValue3,
      hint: const Text('ကျေးရွာ ရွေးချယ်ပါ'),
      onChanged: (String? value) {
        setState(() {
          selectedValue3 = value;
        });
      },
      items: items3.map((String item) {
        return DropdownMenuItem<String>(
          value: item,
          child: Text("$item ကျေးရွာ"),
        );
      }).toList(),
    );
  }
}
